/**********************************************************************/
/* The 1st IPSJ SIG-ARC High-Performance Processor Design Contest     */
/* 320mm Version 2013-10-13                                           */
/**********************************************************************/
#include "../../lib/lib.c"

/**********************************************************************/
#ifdef __ALTERA__
volatile int *init_data = (int*)0x0c000000;
volatile int *init_n    = (int*)0x0c03fff8;
volatile int *init_iter = (int*)0x0c03fffc;
#define BUF1 0xc100000
#define BUF2 0xc200000
#else
volatile int *init_data = (int*)0x00040000;
volatile int *init_n    = (int*)0x0007fff8;
volatile int *init_iter = (int*)0x0007fffc;
#define BUF1 0x100000
#define BUF2 0x200000
#endif

/**********************************************************************/
int main(void) {
    int n         = *init_n;
    int iteration = *init_iter;

    mylib_display_char('s');
    mylib_display_char('t');
    mylib_display_char('e');
    mylib_display_char('n');
    mylib_display_char('c');
    mylib_display_char('i');
    mylib_display_char('l');
    mylib_display_char(' ');
    mylib_display_char('n');
    mylib_display_char('=');
    mylib_display_dec(n);
    mylib_display_char(' ');
    mylib_display_char('i');
    mylib_display_char('=');
    mylib_display_dec(iteration);
    mylib_display_newline();
    
    int *buf1 = (int*) BUF1;
    int *buf2 = (int*) BUF2;

    int x, y, i;

    int d = 0;
    for(y=0; y<n; y++) {
        for(x=0; x<n; x++) {
            buf1[x + y*n] = init_data[d % (64*1024)];
            buf2[x + y*n] = 0;
            d++;
        }
    }

    for(i=0; i<(iteration/2); i++){

        for(y=1; y<n-1; y++) {
            for(x=1; x<n-1; x++) {
                buf2[(x) + (y)*n] =
                    (buf1[(x  ) + (y-1)*n] + buf1[(x-1) + (y  )*n] +
                     buf1[(x+1) + (y  )*n] + buf1[(x  ) + (y+1)*n] +
                     buf1[(x-1) + (y-1)*n] + buf1[(x+1) + (y-1)*n] +
                     buf1[(x-1) + (y+1)*n] + buf1[(x+1) + (y+1)*n] +
                     buf1[(x  ) + (y  )*n]) / 9;
            }
        }
        buf2[n+1] = 0x9999999; // hot spot

        for(y=1; y<n-1; y++) {
            for(x=1; x<n-1; x++) {
                buf1[(x) + (y)*n] =
                    (buf2[(x  ) + (y-1)*n] + buf2[(x-1) + (y  )*n] +
                     buf2[(x+1) + (y  )*n] + buf2[(x  ) + (y+1)*n] +
                     buf2[(x-1) + (y-1)*n] + buf2[(x+1) + (y-1)*n] +
                     buf2[(x-1) + (y+1)*n] + buf2[(x+1) + (y+1)*n] +
                     buf2[(x  ) + (y  )*n]) / 9;
            }
        }
        buf1[n+1] = 0x9999999; // hot spot

    }

    mylib_display_newline();

    for(y = 0; y < 16; y++) {
        for(x = 0; x < 8; x++) {
            mylib_display_hex(buf1[x + y*n]);
            mylib_display_char(' ');
        }
        mylib_display_newline();
    }

    int sum = 0;
    for(y=0; y<n; y++) {
        for(x=0; x<n; x++) {
            sum += buf1[x + y*n];
        }
    }
    mylib_display_hex(sum);
    mylib_display_newline();

    mylib_finalize();
    return 0;
}
/**********************************************************************/
